#ifndef HUMANUSlogger_H
#define HUMANUSlogger_H

#include "spdlog/spdlog.h"
#include "spdlog/sinks/stdout_color_sinks.h"
#include "spdlog/sinks/basic_file_sink.h"
#include "spdlog/sinks/rotating_file_sink.h"
#include "spdlog/sinks/daily_file_sink.h"
#include "spdlog/sinks/dist_sink.h"

#include <string>
#include <filesystem>
#include "config.h"

namespace humanus {

static spdlog::level::level_enum _print_level = spdlog::level::info;

/**
 * @brief Adjust the log level
 * @param print_level The console output log level
 * @param logfile_level The file record log level
 * @param name The log file name prefix
 * @return The log record instance
 */
extern std::shared_ptr<spdlog::logger> define_log_level(spdlog::level::level_enum print_level = spdlog::level::info, 
                                               spdlog::level::level_enum logfile_level = spdlog::level::debug, 
                                               std::string name = "");

static std::shared_ptr<spdlog::logger> logger = define_log_level();

} // namespace humanus

#endif